



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Robot framework--内置库xml学习（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Robot framework--内置库xml学习（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 07:48:56 </span>
						</div>
										<div class="post-content">
											
		<div>
<pre class="prettyprint linenums"> Using lxml<br />
 By default this library uses Python's standard ElementTree module for parsing XML, but it can be configured to use lxml module instead when importing the library. The resulting element structure has same API regardless which module is used for parsing.<br />
 The main benefits of using lxml is that it supports richer xpath syntax than the standard ElementTree and enables using Evaluate Xpath keyword. It also preserves the doctype and possible namespace prefixes saving XML.<br />
 The lxml support is new in Robot Framework 2.8.5.</pre>
</div>
<h1>Robot framework--内置库xml学习（一）</h1>
<p>学习XML内置库，我认为需要掌握以下几个知识点：</p>
<p>第一：内置库的概念？有哪些内置库，大概都有什么关键字？有区分版本吗？跟RF版本有关么？为什么内置库有些需要import，有些不需要import？</p>
<p>第二：XML内置库使用的是python的哪个标准库？对这个标准库需要有哪些基本的了解？</p>
<p>第三：内置库是怎么构建起来的？基本关键字是否能灵活的使用？</p>
<p>第四：有时候可能需要稍微修改下内置库，比如增加一些关键字等，该怎么修改？</p>
<p>1、内置库的概念</p>
<p>　　内置库在官网上称为standard library，即标准库；其他比如：seleniumlibrary、androidlibrary等，官网称为external library，即外部库，第三方库。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/785209/201711/785209-20171106202141513-116066756.png" /></p>
<p>　　（1）对于标准库，这些库直接绑定在robot framework内，在python安装目录下\lib\site-packages\robot\libraries下可以看到，无需在下载。<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/785209/201711/785209-20171106202534700-1866455444.png" /></p>
<p>　　（2）对于外部库，需要根据个人或者公司需要，下载之后安装导入才能使用的。</p>
<p>　　对于标准库，又分两类，类似于builtin库是robot framework自动加载到内存的，安装后按下F5就能直接使用，不需要import；而xml库需要在再次import才能正常使用。因为BuiltIn library 提供了很多常用的关键字，比如<a href="http://robotframework.org/robotframework/2.7/libraries/BuiltIn.html#Should Be Equal" rel="external nofollow noreferrer">Should Be Equal</a>，<a href="http://robotframework.org/robotframework/2.7/libraries/BuiltIn.html#Convert To Integer" rel="external nofollow noreferrer">Convert To Integer</a>等，所以RF就把这个常用的库自动加载到了内存。</p>
<p>不同版本的RF，支持不同的内置库而且相同的内置库里的关键字可能也是不一样的，以RF3.0（使用命令robot --version查看RF版本）为例，3.0是目前最新的RF的版本，支持很多的内置库，查看python安装目录下\Lib\site-packages\robot下的py文件，可以看到：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/785209/201711/785209-20171106203112403-383403256.png" /></p>
<p>　　基本官网写的10个标准库都能在这里面找到相应的py文件。BuiltIn，Collections，DateTime，Dialogs，Process，OperatingSystem，Remote（没有关键字，暂时不算在内），Screenshot，String，Telnet，XML.这11个库，有些是在RF2.0的时候就已经有了的，最晚的DateTime，Process，XML是在RF2.8之后才内置的，也就是说如果当前使用的是RF2.8之前的版本，内置库是无法直接import XML就是使用的，需要下载安装才能使用，这点需要注意下，不同的RF版本，相同的标准库之间也是会细微的区别，这需要仔细的去查看保准库内每个版本的使用文档。</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/785209/201711/785209-20171106204959075-264997895.png" /></p>
<p>2、11个标准库的简介</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/849009/201605/849009-20160526112238772-1059249168.png" /></p>
<p>这个表的来源是来自<a href="http://robotframework.org/robotframework/#standard-libraries" rel="external nofollow noreferrer">官网</a>的，官网的用户手册文档已经描述的非常详细了。学习的时候可以详细的查看官网的相关文档。</p>
<p>3、XML内置库的学习</p>
<p>　　&nbsp; 从内置库的XML的源码可以看出，RF使用的是ETree来对xml进行解析的，部分源码如下：</p>
<div>
<pre class="prettyprint linenums"> import copy<br />
 import re<br />
 import os

 try:<br />
     from lxml import etree as lxml_etree<br />
 except ImportError:<br />
     lxml_etree = None

 from robot.api import logger<br />
 from robot.libraries.BuiltIn import BuiltIn<br />
 from robot.utils import (asserts, ET, ETSource, is_string, is_truthy,<br />
                          plural_or_not as s)<br />
 from robot.version import get_version

 should_be_equal = asserts.assert_equal<br />
 should_match = BuiltIn().should_match

 class XML(object):<br />
  ROBOT_LIBRARY_SCOPE = 'GLOBAL'<br />
     ROBOT_LIBRARY_VERSION = get_version()<br />
     _xml_declaration = re.compile('^&lt;\?xml .*\?&gt;')<br />
   def __init__(self, use_lxml=False):<br />
   　　use_lxml = is_truthy(use_lxml)<br />
         if use_lxml and lxml_etree:<br />
             self.etree = lxml_etree<br />
             self.modern_etree = True<br />
             self.lxml_etree = True<br />
         else:<br />
             self.etree = ET<br />
             self.modern_etree = ET.VERSION &gt;= '1.3'<br />
             self.lxml_etree = False<br />
         if use_lxml and not lxml_etree:<br />
             logger.warn('XML library reverted to use standard ElementTree '<br />
                         'because lxml module is not installed.')

   def parse_xml(self, source, keep_clark_notation=False):<br />
  　　with ETSource(source) as source:<br />
             tree = self.etree.parse(source)<br />
         if self.lxml_etree:<br />
             strip = (lxml_etree.Comment, lxml_etree.ProcessingInstruction)<br />
             lxml_etree.strip_elements(tree, *strip, **dict(with_tail=False))<br />
         root = tree.getroot()<br />
         if not is_truthy(keep_clark_notation):<br />
             NameSpaceStripper().strip(root)<br />
         return root</pre>
<p>　　python提供了几个标准库都可以对xml进行解析，之前我使用的是DOM，基于RF使用的是ETree，便开始学习了下<a href="https://docs.python.org/2/library/xml.etree.elementtree.html?highlight=etree" rel="external nofollow noreferrer">ETree的开发文档</a>。学习对XML文件的操作,那肯定也得对XML本身有最基本的了解，比如XML的用途，树结构，节点类型（DOM），带命名空间的xml。下面是部分的知识点的总结：</p>
<p>xml是一种可扩展的标记语言。要求标记需要成对的出现（有时候会进行简写&lt;b/&gt;）。一个典型的xml文档如下所示：</p>
<div>
<pre class="prettyprint linenums"> &lt;example&gt;<br />
   &lt;first id=""&gt;text&lt;/first&gt;<br />
   &lt;second id=""&gt;<br />
     &lt;child/&gt;<br />
   &lt;/second&gt;<br />
   &lt;third&gt;<br />
     &lt;child&gt;more text&lt;/child&gt;<br />
     &lt;second id="child"/&gt;<br />
     &lt;child&gt;&lt;grandchild/&gt;&lt;/child&gt;<br />
   &lt;/third&gt;<br />
 &lt;/example&gt;</pre>
</div>
</div>
<p>A. 整个xml文档是一个文档节点，属于根节点，比如上述文档的&lt;example&gt;节点就是一个根节点，一个xml文件只能有一个根节点，否则解析的时候胡报错的</p>
<p>B.每个 XML 标签是一个元素节点,比如&lt;first&gt; 和&lt;second&gt;，&nbsp;&lt;third&gt;都属于元素节点，却属于&lt;example&gt;的子节点。</p>
<p>C.attribute值：表示节点元素的属性值，比如first 有一个属性id，属性值为1；second也有id属性，属性值为2，而third没有属性。</p>
<p>D.Text值:表示元素中的文本内容。比如：first 的text值就为1；second没有，third也没有；</p>
<p>一个xml还包含其他的内容：比如处理指令和一些注释；在python的etree标准库解析的过程中，是直接把这二个给剔除掉了。有兴趣的可以根据官网给出的开发文档，把常用的一些方法都敲一遍，主要的还是使用2个类&nbsp;Element Objects和ElementTree Objects。</p>
<p>4、xml官网学习</p>
<div>
<pre class="prettyprint linenums"> XML

 Library version:    3.0.2<br />
 Library scope:    global<br />
 Named arguments:    supported<br />
 Introduction

 Robot Framework test library for verifying and modifying XML documents.<br />
 As the name implies, XML is a test library for verifying contents of XML files. In practice it is a pretty thin wrapper on top of Python's ElementTree XML API.<br />
 The library has the following main usages:<br />
 Parsing an XML file, or a string containing XML, into an XML element structure and finding certain elements from it for for further analysis (e.g. Parse XML and Get Element keywords).<br />
 Getting text or attributes of elements (e.g. Get Element Text and Get Element Attribute).<br />
 Directly verifying text, attributes, or whole elements (e.g Element Text Should Be and Elements Should Be Equal).<br />
 Modifying XML and saving it (e.g. Set Element Text, Add Element and Save XML).<br />
 Table of contents<br />
 Parsing XML<br />
 Using lxml<br />
 Example<br />
 Finding elements with xpath<br />
 Element attributes<br />
 Handling XML namespaces<br />
 Boolean arguments<br />
 Shortcuts<br />
 Keywords</pre>
</div>
<p>　介绍Robot Framework测试库，用于验证和修改XML文档。顾名思义，XML是用于验证XML文件内容的测试库。 实际上，它是Python的ElementTree XML API的一个非常薄的包装器。库有以下主要用途：将XML文件或包含XML的字符串解析为XML元素结构，并从中找出某些元素以供进一步分析（例如，解析XML和获取元素关键字）。获取元素的文本或属性（例如获取元素文本和获取元素属性）。直接验证文本，属性或整个元素（例如元素文本应该与元素应该相等）。修改XML并保存（例如设置元素文本，添加元素和保存XML）。</p>
<div>
<pre class="prettyprint linenums"> Parsing XML<br />
 XML can be parsed into an element structure using Parse XML keyword. It accepts both paths to XML files and strings that contain XML. The keyword returns the root element of the structure, which then contains other elements as its children and their children. Possible comments and processing instructions in the source XML are removed.<br />
 XML is not validated during parsing even if has a schema defined. How possible doctype elements are handled otherwise depends on the used XML module and on the platform. The standard ElementTree strips doctypes altogether but when using lxml they are preserved when XML is saved. With IronPython parsing XML with a doctype is not supported at all.<br />
 The element structure returned by Parse XML, as well as elements returned by keywords such as Get Element, can be used as the source argument with other keywords. In addition to an already parsed XML structure, other keywords also accept paths to XML files and strings containing XML similarly as Parse XML. Notice that keywords that modify XML do not write those changes back to disk even if the source would be given as a path to a file. Changes must always saved explicitly using Save XML keyword.<br />
 When the source is given as a path to a file, the forward slash character (/) can be used as the path separator regardless the operating system. On Windows also the backslash works, but it the test data it needs to be escaped by doubling it (\\). Using the built-in variable ${/} naturally works too.<br />
 解析XML<br />
 可以使用Parse XML关键字将XML解析为元素结构。它接受XML文件和包含XML的字符串的路径。关键字返回结构的根元素，然后包含其他元素作为其子元素和子元素。源XML中的可能注释和处理指令将被删除。<br />
 即使定义了模式，XML在分析过程中也不会被验证。如何处理doctype元素，否则取决于使用的XML模块和平台。标准ElementTree完全去除doctypes，但是当使用lxml时，保存XML时会保留它们。 IronPython用doctype解析XML根本不被支持。<br />
 由Parse XML返回的元素结构以及由Get Element等关键字返回的元素可用作其他关键字的源参数。除已经解析的XML结构之外，其他关键字也接受XML文件的路径和包含XML的字符串，类似于解析XML。请注意，修改XML的关键字不会将这些更改写回到磁盘，即使源将作为文件的路径提供。必须始终使用保存XML关键字保存更改。<br />
 当源被指定为文件的路径时，无论操作系统如何，正斜杠字符（/）都可以用作路径分隔符。在Windows上，反斜杠也可以工作，但是它需要通过加倍（\\）来转义测试数据。使用内置变量$ {/}自然也可以。</pre>
</div>
<p>　　</p>
<p>使用lxml<br />默认情况下，这个库使用Python的标准ElementTree模块来解析XML，但是当导入库时，它可以被配置为使用lxml模块。 无论使用哪个模块解析，生成的元素结构都具有相同的API。<br />使用lxml的主要好处是它支持比标准ElementTree更丰富的xpath语法，并支持使用Evaluate Xpath关键字。 它还保留了doctype和保存XML的可能的名称空间前缀。<br />lxml支持是Robot Framework 2.8.5中的新功能。</p>
<div>
<pre class="prettyprint linenums"> Example<br />
 The following simple example demonstrates parsing XML and verifying its contents both using keywords in this library and in BuiltIn and Collections libraries. How to use xpath expressions to find elements and what attributes the returned elements contain are discussed, with more examples, in Finding elements with xpath and Element attributes sections.<br />
 In this example, as well as in many other examples in this documentation, ${XML} refers to the following example XML document. In practice ${XML} could either be a path to an XML file or it could contain the XML itself.<br />
 &lt;example&gt;<br />
   &lt;first id=""&gt;text&lt;/first&gt;<br />
   &lt;second id=""&gt;<br />
     &lt;child/&gt;<br />
   &lt;/second&gt;<br />
   &lt;third&gt;<br />
     &lt;child&gt;more text&lt;/child&gt;<br />
     &lt;second id="child"/&gt;<br />
     &lt;child&gt;&lt;grandchild/&gt;&lt;/child&gt;<br />
   &lt;/third&gt;<br />
   &lt;html&gt;<br />
     &lt;p&gt;<br />
       Text with &lt;b&gt;bold&lt;/b&gt; and &lt;i&gt;italics&lt;/i&gt;.<br />
     &lt;/p&gt;<br />
   &lt;/html&gt;<br />
 &lt;/example&gt;<br />
 ${root} =    Parse XML    ${XML}<br />
 Should Be Equal    ${root.tag}    example<br />
 ${first} =    Get Element    ${root}    first<br />
 Should Be Equal    ${first.text}    text<br />
 Dictionary Should Contain Key    ${first.attrib}    id<br />
 Element Text Should Be    ${first}    text<br />
 Element Attribute Should Be    ${first}    id    1<br />
 Element Attribute Should Be    ${root}    id    1    xpath=first<br />
 Element Attribute Should Be    ${XML}    id    1    xpath=first<br />
 Notice that in the example three last lines are equivalent. Which one to use in practice depends on which other elements you need to get or verify. If you only need to do one verification, using the last line alone would suffice. If more verifications are needed, parsing the XML with Parse XML only once would be more efficient.</pre>
</div>
<p>例<br />下面的简单示例演示解析XML并验证其内容，使用此库中的关键字以及BuiltIn和Collections库中的关键字。讨论如何使用xpath表达式来查找元素以及返回元素包含的属性，以及使用xpath和Element属性部分查找元素的更多示例。<br />在本例中，以及本文档中的许多其他示例中，$ {XML}引用以下示例XML文档。实际上，$ {XML}既可以是XML文件的路径，也可以包含XML本身。<br />&lt;实例&gt;<br />&nbsp;&nbsp;&lt;first id =&ldquo;1&rdquo;&gt;文字&lt;/ first&gt;<br />&nbsp;&nbsp;&lt;second id =&ldquo;2&rdquo;&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&lt;子/&gt;<br />&nbsp;&nbsp;&lt;/秒&gt;<br />&nbsp;&nbsp;&lt;第三&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&lt;child&gt;更多文字&lt;/ child&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&lt;second id =&ldquo;child&rdquo;/&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&lt;子&gt; &lt;孙子/&gt; &lt;/子&gt;<br />&nbsp;&nbsp;&lt;/第三&gt;<br />&nbsp;&nbsp;&lt;HTML&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&lt;P&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;带有&lt;b&gt;粗体&lt;/ b&gt;和&lt;i&gt;斜体&lt;/ i&gt;的文本。<br />&nbsp;&nbsp;&nbsp;&nbsp;&lt;/ p&gt;<br />&nbsp;&nbsp;&lt;/ HTML&gt;<br />&lt;/示例&gt;<br />$ {root} =解析XML $ {XML}<br />应该是等于$ {root.tag}的例子<br />$ {first} =首先获取元素$ {root}<br />应该等于$ {first.text}文本<br />字典应包含密钥$ {first.attrib} id<br />元素文本应该是$ {first}文本<br />元素属性应该是$ {first} id 1<br />元素属性应该是$ {root} id 1 xpath = first<br />元素属性应该是$ {XML} id 1 xpath = first<br />注意在这个例子中最后三行是等价的。在实践中使用哪一个取决于您需要获取或验证的其他元素。如果您只需要进行一次验证，单单使用最后一行就足够了。如果需要更多的验证，只用解析XML解析XML将会更有效率。</p>
<div>
<pre class="prettyprint linenums"> Finding elements with xpath<br />
 ElementTree, and thus also this library, supports finding elements using xpath expressions. ElementTree does not, however, support the full xpath syntax, and what is supported depends on its version. ElementTree 1.3 that is distributed with Python 2.7 supports richer syntax than earlier versions.<br />
 The supported xpath syntax is explained below and ElementTree documentation provides more details. In the examples ${XML} refers to the same XML structure as in the earlier example.<br />
 If lxml support is enabled when importing the library, the whole xpath 1.0 standard is supported. That includes everything listed below but also lot of other useful constructs.<br />
 Tag names<br />
 When just a single tag name is used, xpath matches all direct child elements that have that tag name.<br />
 ${elem} =    Get Element    ${XML}    third<br />
 Should Be Equal    ${elem.tag}    third<br />
 @{children} =    Get Elements    ${elem}    child<br />
 Length Should Be    ${children}    2<br />
 Paths<br />
 Paths are created by combining tag names with a forward slash (/). For example, parent/child matches all child elements under parent element. Notice that if there are multiple parent elements that all have child elements, parent/child xpath will match all these child elements.<br />
 ${elem} =    Get Element    ${XML}    second/child<br />
 Should Be Equal    ${elem.tag}    child<br />
 ${elem} =    Get Element    ${XML}    third/child/grandchild<br />
 Should Be Equal    ${elem.tag}    grandchild<br />
 Wildcards<br />
 An asterisk (*) can be used in paths instead of a tag name to denote any element.<br />
 @{children} =    Get Elements    ${XML}    */child<br />
 Length Should Be    ${children}    3<br />
 Current element<br />
 The current element is denoted with a dot (.). Normally the current element is implicit and does not need to be included in the xpath.<br />
 Parent element<br />
 The parent element of another element is denoted with two dots (..). Notice that it is not possible to refer to the parent of the current element. This syntax is supported only in ElementTree 1.3 (i.e. Python/Jython 2.7 and newer).<br />
 ${elem} =    Get Element    ${XML}    */second/..<br />
 Should Be Equal    ${elem.tag}    third<br />
 Search all sub elements<br />
 Two forward slashes (//) mean that all sub elements, not only the direct children, are searched. If the search is started from the current element, an explicit dot is required.<br />
 @{elements} =    Get Elements    ${XML}    .//second<br />
 Length Should Be    ${elements}    2<br />
 ${b} =    Get Element    ${XML}    html//b<br />
 Should Be Equal    ${b.text}    bold<br />
 Predicates<br />
 Predicates allow selecting elements using also other criteria than tag names, for example, attributes or position. They are specified after the normal tag name or path using syntax path[predicate]. The path can have wildcards and other special syntax explained above.<br />
 What predicates ElementTree supports is explained in the table below. Notice that predicates in general are supported only in ElementTree 1.3 (i.e. Python/Jython 2.7 and newer).<br />
 Predicate    Matches    Example<br />
 @attrib    Elements with attribute attrib.    second[@id]<br />
 @attrib="value"    Elements with attribute attrib having value value.    *[@id=""]<br />
 position    Elements at the specified position. Position can be an integer (starting from 1), expression last(), or relative expression like last() - 1.    third/child[1]<br />
 tag    Elements with a child element named tag.    third/child[grandchild]<br />
 Predicates can also be stacked like path[predicate1][predicate2]. A limitation is that possible position predicate must always be first.</pre>
</div>
<p>用xpath查找元素<br />ElementTree，也就是这个库，支持使用xpath表达式查找元素。然而，ElementTree不支持完整的xpath语法，支持的内容取决于它的版本。与Python 2.7分布的ElementTree 1.3支持比早期版本更丰富的语法。<br />受支持的xpath语法如下所述，ElementTree文档提供了更多细节。在示例中，$ {XML}引用与前面示例中相同的XML结构。<br />如果在导入库时启用了lxml支持，则支持整个xpath 1.0标准。这包括下面列出的一切，但也有很多其他有用的结构。<br />标签名称<br />当仅使用单个标签名称时，xpath将匹配具有该标签名称的所有直接子元素。<br />$ {elem} =获取元素$ {XML}的三分之一<br />应该等于$ {elem.tag}第三<br />@ {children} =获取元素$ {elem}孩子<br />长度应该是$ {children} 2<br />路径<br />路径是通过将标记名称与正斜杠（/）组合来创建的。例如，父/子匹配父元素下的所有子元素。请注意，如果有多个父元素都具有子元素，则父/子xpath将匹配所有这些子元素。<br />$ {elem} =获取元素$ {XML}秒/子<br />应该是平等$ {elem.tag}孩子<br />$ {elem} =获取元素$ {XML}第三/子/孙<br />应该等于$ {elem.tag}孙子<br />通配符<br />星号（*）可用于路径而不是标签名称来表示任何元素。<br />@ {children} =获取元素$ {XML} * / child<br />长度应该是$ {children} 3<br />当前元素<br />当前元素用点（。）表示。通常，当前元素是隐式的，不需要包含在xpath中。<br />父元素<br />另一个元素的父元素用两个点（..）表示。请注意，不可能引用当前元素的父元素。这个语法仅在ElementTree 1.3（即Python / Jython 2.7和更新版本）中被支持。<br />$ {elem} =获取元素$ {XML} * /秒/ ..<br />应该等于$ {elem.tag}第三<br />搜索所有子元素<br />两个正斜杠（//）意味着搜索所有子元素，而不仅仅是直接子元素。如果搜索从当前元素开始，则需要一个明确的点。<br />@ {elements} =获取元素$ {XML}。// second<br />长度应该是$ {elements} 2<br />$ {b} =获取元素$ {XML} html // b<br />应该等于$ {b.text}大胆<br />谓词<br />谓词允许使用标记名称以外的其他标准来选择元素，例如属性或位置。它们是在使用语法path [predicate]的标准名称或路径之后指定的。路径可以有通配符和上面解释的其他特殊语法。<br />下表说明了ElementTree支持的谓词。请注意，一般来说谓词仅在ElementTree 1.3（即Python / Jython 2.7及更新版本）中受支持。<br />谓词匹配示例<br />@attrib具有属性attrib的元素。第二[@id]<br />@ attrib =&ldquo;value&rdquo;属性attrib具有值的元素。 * [@ ID = &ldquo;2&rdquo;]<br />在指定位置放置元素。位置可以是一个整数（从1开始），表达式last（）或像last（） - 1的相对表达式。third / child [1]<br />标签具有子元素名称标签的元素。第三/儿童[孙子]<br />谓词也可以像路径[predicate1] [predicate2]一样堆叠。一个限制是可能的位置谓词必须始终是第一位的。</p>
<p>　</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyrgrg8.html">常见http status code</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jplwg9.html">CSS中加号、星号及其他符号的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkd2z9.html">SQL Server 2012日志文件误删除数据库质疑后的相关恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4z4jq.html">后缀数组---Milk Patterns</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ezk6m8.html">node&period;js之excel文件读取</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p0rryq.html">groovy-真值</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x04kz8.html">StackTrace，Trim</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg5d09.html">matlab s变换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e0x69.html">jQuery1&period;6以上版本prop和attr的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn5nx0q.html">python学习第二课要点记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0yp70q.html">加深理解UIView，UIResponder，UIController</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey46jm9.html">基于python的《Hadoop权威指南》一书中气象数据下载和map reduce化数据处理及其可视化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp2k669.html">SpringMVC源码情操陶冶-ViewResolver视图解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpl64r9.html">阿里云ECS&plus;CentOS 7&period;0&plus;Docker&plus;Redmine环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojrk35q.html">【LSGDOJ1836】&colon; 量化交易 贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m3ex48.html">十分钟学会Java8的lambda表达式和Stream API</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7mwr9.html">Windows上安装MySQL的完整教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjow3j8.html">&lbrack;Alpha阶段&rsqb;第九次Scrum Meeting</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kenvz9.html">使用SO&lowbar;REVTIMEO套接字选项为recvfrom设置超时</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy1yr2q.html">爬虫之requests</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gk13vq.html">rocketmq安装与基本操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jvv13q.html">phpstorm中设置代码上传到github</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zynnm19.html">Ubuntu 安装 VS code</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1065lq.html">bzoj 2084 Antisymmetry - Manacher</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll3rkeq.html">Codeforces 40E Number Table - 组合数学</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyj73jq.html">js导读&comma;js引入&comma;js选择器&comma;事件&comma;操作页面文档&comma;计算后样式&comma;数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/960wrv39.html">PID算法控制简单理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjvwk09.html">default activity not found的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwo0zk8.html">安装ubuntu的坑&amp;amp&semi;RHEL7配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w25y0q.html">如何自己烧制全文RSS（打造自己RSS源）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
